diff --git a/web/pgadmin/tools/psql/tests/test_start_process.py b/web/pgadmin/tools/psql/tests/test_start_process.py
new file mode 100644
index 00000000..1245de3f
--- /dev/null
+++ b/web/pgadmin/tools/psql/tests/test_start_process.py
@@ -0,0 +1,57 @@
+import uuid
+import config
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from regression import parent_node_dict
+from regression.test_setup import config_data
+from pgadmin.utils import server_utils as server_utils
+from pgAdmin4 import app
+from .... import socketio
+
+
+class PSQLStartProcess(BaseTestGenerator):
+    def setUp(self):
+        self.db_name = "psqltestdb_{0}".format(str(uuid.uuid4())[1:8])
+        database_info = parent_node_dict["database"][-1]
+        self.did = database_info["db_id"]
+        self.sid = parent_node_dict["server"][-1]["server_id"]
+        self.sgid = config_data["server_group"]
+        config.ENABLE_PSQL = True
+
+        self.server_con = server_utils.connect_server(self, self.sid)
+
+    def runTest(self):
+        # Fetch flask client to access current user and other cookies.
+        flask_client = app.test_client()
+        flask_client.get('/')
+        self.test_client = socketio.test_client(app, namespace='/pty',
+                                                flask_test_client=flask_client)
+        self.assertTrue(self.test_client.is_connected('/pty'))
+        received = self.test_client.get_received('/pty')
+
+        assert received[0]['name'] == 'connected'
+        assert received[0]['args'][0]['sid'] != ''
+
+        import random
+        trans_id = random.randint(1, 9999999)
+
+        data = {
+            'sid': self.sid,
+            'db': 'postgres',
+            'pwd': self.server['db_password'],
+            'user': self.server['username']
+        }
+
+        self.test_client.emit('start_process', data, namespace='/pty')
+        self.test_client.get_received('/pty')
+
+        self.test_client.disconnect(namespace='/pty')
+        self.assertFalse(self.test_client.is_connected('/pty'))
+
+    def tearDown(self):
+        connection = utils.get_db_connection(self.server['db'],
+                                             self.server['username'],
+                                             self.server['db_password'],
+                                             self.server['host'],
+                                             self.server['port'])
+        utils.drop_database(connection, self.db_name)
diff --git a/web/pgadmin/tools/psql/tests/test_start_process_fail.py b/web/pgadmin/tools/psql/tests/test_start_process_fail.py
new file mode 100644
index 00000000..0acc7be2
--- /dev/null
+++ b/web/pgadmin/tools/psql/tests/test_start_process_fail.py
@@ -0,0 +1,48 @@
+import uuid
+import config
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from regression import parent_node_dict
+from regression.test_setup import config_data
+from pgAdmin4 import app
+from .... import socketio
+
+
+class PSQLStartProcessFail(BaseTestGenerator):
+    def setUp(self):
+        self.db_name = "psqltestdb_{0}".format(str(uuid.uuid4())[1:8])
+        self.sid = parent_node_dict["server"][-1]["server_id"]
+        self.did = utils.create_database(self.server, self.db_name)
+        self.sgid = config_data["server_group"]
+        config.ENABLE_PSQL = True
+
+    def runTest(self):
+        self.test_client = socketio.test_client(app, namespace='/pty')
+        self.assertTrue(self.test_client.is_connected('/pty'))
+        received = self.test_client.get_received('/pty')
+
+        assert received[0]['name'] == 'connected'
+        assert received[0]['args'][0]['sid'] != ''
+
+        data = {
+            'sid': self.sid,
+            'db': 'postgres',
+            'pwd': self.server['db_password'],
+            'user': self.server['username']
+        }
+        config.ENABLE_PSQL = False
+        self.test_client.emit('start_process', data, namespace='/pty')
+        received = self.test_client.get_received('/pty')
+
+        assert received[0]['name'] == 'conn_not_allow'
+
+        self.test_client.disconnect(namespace='/pty')
+        self.assertFalse(self.test_client.is_connected('/pty'))
+
+    def tearDown(self):
+        connection = utils.get_db_connection(self.server['db'],
+                                             self.server['username'],
+                                             self.server['db_password'],
+                                             self.server['host'],
+                                             self.server['port'])
+        utils.drop_database(connection, self.db_name)
diff --git a/web/pgadmin/tools/psql/tests/utils.py b/web/pgadmin/tools/psql/tests/utils.py
new file mode 100644
index 00000000..85bd5373
--- /dev/null
+++ b/web/pgadmin/tools/psql/tests/utils.py
@@ -0,0 +1,6 @@
+import os
+import json
+
+CURRENT_PATH = os.path.dirname(os.path.realpath(__file__))
+with open(CURRENT_PATH + "/psql_test_data.json") as data_file:
+    test_cases = json.load(data_file)
diff --git a/web/pgadmin/utils/csrf.py b/web/pgadmin/utils/csrf.py
index 23abfffa..71ae82ea 100644
--- a/web/pgadmin/utils/csrf.py
+++ b/web/pgadmin/utils/csrf.py
@@ -38,6 +38,7 @@ class _PGCSRFProtect(CSRFProtect):
             'pgadmin.tools.schema_diff.ddl_compare',
             'pgadmin.authenticate.login',
             'pgadmin.tools.erd.panel',
+            'pgadmin.tools.psql.panel',
         ]
 
         for exempt in exempt_views:
diff --git a/web/pgadmin/utils/driver/psycopg2/server_manager.py b/web/pgadmin/utils/driver/psycopg2/server_manager.py
index 2a951b6e..3be5d833 100644
--- a/web/pgadmin/utils/driver/psycopg2/server_manager.py
+++ b/web/pgadmin/utils/driver/psycopg2/server_manager.py
@@ -527,6 +527,15 @@ WHERE db.oid = {0}""".format(did))
 
         return None
 
+    def extract_password(self):
+        if self.password:
+            crypt_key_present, crypt_key = get_crypt_key()
+            if not crypt_key_present:
+                return False, crypt_key
+
+            password = decrypt(self.password, crypt_key).decode()
+            return password
+
     def export_password_env(self, env):
         if self.password:
             crypt_key_present, crypt_key = get_crypt_key()
diff --git a/web/pgadmin/utils/preferences.py b/web/pgadmin/utils/preferences.py
index 15ceeb1a..e9efe479 100644
--- a/web/pgadmin/utils/preferences.py
+++ b/web/pgadmin/utils/preferences.py
@@ -72,6 +72,7 @@ class _Preference(object):
         self.select2 = kwargs.get('select2', None)
         self.fields = kwargs.get('fields', None)
         self.allow_blanks = kwargs.get('allow_blanks', None)
+        self.disabled = kwargs.get('disabled', False)
 
         # Look into the configuration table to find out the id of the specific
         # preference.
@@ -252,6 +253,7 @@ class _Preference(object):
             'select2': self.select2,
             'value': self.get(),
             'fields': self.fields,
+            'disabled': self.disabled,
         }
         return res
 
@@ -414,6 +416,7 @@ class Preferences(object):
         :param fields: field schema (if preference has more than one field to
                         take input from user e.g. keyboardshortcut preference)
         :param allow_blanks: Flag specify whether to allow blank value.
+        :param disabled: Flag specify whether to disable the setting or not.
         """
         min_val = kwargs.get('min_val', None)
         max_val = kwargs.get('max_val', None)
@@ -423,6 +426,7 @@ class Preferences(object):
         select2 = kwargs.get('select2', None)
         fields = kwargs.get('fields', None)
         allow_blanks = kwargs.get('allow_blanks', None)
+        disabled = kwargs.get('disabled', False)
 
         cat = self.__category(category, category_label)
         if name in cat['preferences']:
@@ -439,7 +443,8 @@ class Preferences(object):
         (cat['preferences'])[name] = res = _Preference(
             cat['id'], name, label, _type, default, help_str=help_str,
             min_val=min_val, max_val=max_val, options=options,
-            select2=select2, fields=fields, allow_blanks=allow_blanks
+            select2=select2, fields=fields, allow_blanks=allow_blanks,
+            disabled=disabled
         )
 
         return res
diff --git a/web/webpack.config.js b/web/webpack.config.js
index 779f2faa..f631178b 100644
--- a/web/webpack.config.js
+++ b/web/webpack.config.js
@@ -355,6 +355,7 @@ module.exports = [{
     debugger_direct: './pgadmin/tools/debugger/static/js/direct.js',
     schema_diff: './pgadmin/tools/schema_diff/static/js/schema_diff_hook.js',
     erd_tool: './pgadmin/tools/erd/static/js/erd_tool_hook.js',
+    psql_tool: './pgadmin/tools/psql/static/js/index.js',
     file_utils: './pgadmin/misc/file_manager/static/js/utility.js',
     'pgadmin.style': pgadminCssStyles,
     pgadmin: pgadminScssStyles,
@@ -493,7 +494,7 @@ module.exports = [{
           ],
         },
       },
-    }, {
+    },{
       test: require.resolve('./node_modules/acitree/js/jquery.aciTree.min'),
       use: {
         loader: 'imports-loader',
@@ -532,6 +533,7 @@ module.exports = [{
             'pure|pgadmin.tools.storage_manager',
             'pure|pgadmin.tools.search_objects',
             'pure|pgadmin.tools.erd_module',
+            'pure|pgadmin.tools.psql_module',
           ],
         },
       },
diff --git a/web/webpack.shim.js b/web/webpack.shim.js
index 074b2580..e0b28091 100644
--- a/web/webpack.shim.js
+++ b/web/webpack.shim.js
@@ -159,6 +159,15 @@ var webpackShimConfig = {
     'jquery.acisortable': path.join(__dirname, './node_modules/acitree/js/jquery.aciSortable.min'),
     'jquery.acifragment': path.join(__dirname, './node_modules/acitree/js/jquery.aciFragment.min'),
 
+    //xterm
+    'xterm': path.join(__dirname, './node_modules/xterm/lib/xterm.js'),
+    'xterm-addon-fit': path.join(__dirname, './node_modules/xterm-addon-fit/lib/xterm-addon-fit.js'),
+    'xterm-addon-web-links': path.join(__dirname, './node_modules/xterm-addon-web-links/lib/xterm-addon-web-links.js'),
+    'xterm-addon-search': path.join(__dirname, './node_modules/xterm-addon-search/lib/xterm-addon-search.js'),
+
+    //socket
+    'socketio': path.join(__dirname, './node_modules/socket.io-client/dist/socket.io.js'),
+
     // Backbone and Backgrid
     'backbone': path.join(__dirname, './node_modules/backbone/backbone'),
     'backbone.undo': path.join(__dirname, './node_modules/backbone-undo/Backbone.Undo'),
@@ -288,6 +297,8 @@ var webpackShimConfig = {
     'pgadmin.tools.storage_manager': path.join(__dirname, './pgadmin/tools/storage_manager/static/js/storage_manager'),
     'pgadmin.tools.erd_module': path.join(__dirname, './pgadmin/tools/erd/static/js/erd_module'),
     'pgadmin.tools.erd': path.join(__dirname, './pgadmin/tools/erd/static/js'),
+    'pgadmin.tools.psql_module': path.join(__dirname, './pgadmin/tools/psql/static/js/psql_module'),
+    'pgadmin.tools.psql': path.join(__dirname, './pgadmin/tools/psql/static/js'),
     'pgadmin.search_objects': path.join(__dirname, './pgadmin/tools/search_objects/static/js'),
     'pgadmin.tools.user_management': path.join(__dirname, './pgadmin/tools/user_management/static/js/user_management'),
     'pgadmin.user_management.current_user': '/user_management/current_user',
diff --git a/web/webpack.test.config.js b/web/webpack.test.config.js
index e0b6fd69..3cc079f9 100644
--- a/web/webpack.test.config.js
+++ b/web/webpack.test.config.js
@@ -177,6 +177,7 @@ module.exports = {
       'pgadmin.browser.preferences': path.join(__dirname, './pgadmin/browser/static/js/preferences'),
       'pgadmin.browser.activity': path.join(__dirname, './pgadmin/browser/static/js/activity'),
       'pgadmin.tools.erd': path.join(__dirname, './pgadmin/tools/erd/static/js'),
+      'pgadmin.tools.psql': path.join(__dirname, './pgadmin/tools/psql/static/js'),
       'bundled_codemirror': path.join(__dirname, './pgadmin/static/bundle/codemirror'),
       'tools': path.join(__dirname, './pgadmin/tools/'),
       'pgadmin.user_management.current_user': regressionDir + '/javascript/fake_current_user',
